use 02_meps_prep_02.dta, clear
// Compute Transition Probabilites
	set matsize 800
	mat a=J((((100-20)/1+1)*2 * 3) ,3,.)
	local i = 1 
	forvalues age = 20(1)100 {
		forvalues educ = 1/2 {
			forvalues highcost1 = 1/3 {  
					mat a[`i',1] = `age'
					mat a[`i',2] = `educ'
					mat a[`i',3] = `highcost1'
					local i = `i'+1
				}
			}
	}
	mat colnames a = agef educf health1f
* Regression Model
// Transition Probability
   	oprobit highcost2 i.highcost1 c.aget1##i.edcat c.aget1##c.aget1##i.edcat [pweight = longwt] ,r
    eststo oprobit
    foreach o in 1 2 3 4 {
        margins, pr (outcome(`o')) at(aget1=(20(1)100) edcat=(1/2) highcost1=(1/3)) atmeans vsquish post
		matrix bph_all`o' = e(b)'
		estimates restore oprobit
    }		
	mata : st_matrix("b", sort(st_matrix("a"), (3,1,2)))

	mat ph_all = b,  bph_all1, bph_all2, bph_all3, bph_all4
	clear
	svmat ph_all
	rename ph_all1  age
	rename ph_all2 education
	rename ph_all3 health
	label define highcostl 1"1.LE" 2"2.HE"  3"3.SE", modify
	label values highcost1 highcostl
	sort age education health
	rename (ph_all4 ph_all5 ph_all6 ph_all7) (pb_h1 pb_h2 pb_h3 pb_h4)
	export excel using trpb_health.xls, firstrow(variables) replace

// Survival Probability
	oprobit died i.highcost1 c.aget1##c.aget1 i.edcat [pweight = longwt] ,r
	margins, predict(outcome(1)) at(aget1=(20(1)100) edcat=(1/2) highcost1=(1/3)) atmeans vsquish post
	matrix bph_dd = e(b)'
	mata : st_matrix("b", sort(st_matrix("a"), (3,1,2)))
	mat ph_d = b, bph_dd
	clear
	svmat ph_d
	rename ph_d1 aget1
	rename ph_d2 edcat
	rename ph_d3 highcost1
	label define highcostl 1"1.LE" 2"2.HE"  3"3.SE", modify
	label values highcost1 highcostl
	rename ph_d4 dead
	export excel using trpb_dead.xls, firstrow(variables) replace	
