module params

implicit none

double precision, parameter :: zero=0, one=1, small=1e-6

!mpi variables
integer :: nproc, ierr, rank
double precision :: codetime,codestart,codefinish 

!age, health
integer, parameter :: ne=2, nj=65, nh=3, nj1=81

!age and health counters
integer :: ec, jc, hc
integer :: hcc

!cut offs
double precision, parameter :: pc1=.6, pc2=.999
!double precision, parameter :: pc1=1./3., pc2=2./3.

!percentiles for current period and next period
double precision, dimension(ne,nj) :: perc1, perc2, perc1p, perc2p

!transition probablities
double precision, dimension(ne,nj,nh,nh) :: pi_h 
double precision, dimension(ne,nj1,nh,nh) :: pi_h_trend, pi_h_adjusted 

!death probabilities, survival probablities and medical expense
double precision, dimension(ne,nj,nh) :: death, med_expense, psi
double precision, dimension(ne,nj1,nh) :: med_expense_trend, psi_trend, psi_adjusted

double precision, dimension(nj1,nh) :: med_expense_avg
double precision, dimension(nj1,nh) :: med_expense_avg_trend

double precision, dimension(nj) :: age
double precision, dimension(nj1) :: age_trend
integer, parameter :: poly_power=2

double precision, dimension(ne,nj,nh) :: Nu
double precision, dimension(ne,nj1,nh) :: Nu_trend, Nu_adjusted
double precision, dimension(ne,nh) :: max_error
double precision, dimension(ne,nh) :: max_error_trend, max_error_adjusted

double precision, parameter :: nn=.011

double precision, parameter :: y_2010=48374.05646

double precision, dimension(nj1) :: psibyage_census, psibyage_meps, psibyage_trend, psibyage_adjusted

double precision, parameter :: nc_frac=0.729989031

end module params