! This is a subroutine to solve for steady state asset distribution
subroutine distss

use params
IMPLICIT NONE

integer::hcc,scc,inds(2)
double precision :: vals(2),dummy, help(ne,nh,J)
double precision :: abarss, lbarss, labarss, cbarss, hbarss

double precision :: alevel, yinc

!start with zero assets and full private insurance
Phiss=0

    do gc=1,ng
    do ec=1,ne
    do hc=1,nh
    do sc=1,ns
    Phiss(gc,ec,hc,sc,1,1)=put_h(ec,1,hc)*put(ec,sc)*put_e(ec)*put_g(gc)
    end do
    end do
    end do
    end do

    ! Loop to find distributions for generations 2 to J
    do tc=2,J
    do gc=1,ng
    do ec=1,ne
    do hc=1,nh
    do sc=1,ns
    do ac=1,na
                                                
        call basefun(grida,na,afunss(gc,ec,hc,sc,ac,tc-1),vals,inds)
        
        ! Loop over states of idiosyncratic productivity for health				
        do hcc=1,nh
        ! Loop over states of idiosyncratic productivity
        do scc=1,ns	

            if ( g_dgss(gc,ec,hc,sc,ac,tc-1) .eq. 1 .and. ( gc .eq. 1 .or. gc .eq. 2 ) ) then 

            Phiss(1,ec,hcc,scc,inds(1),tc)=Phiss(1,ec,hcc,scc,inds(1),tc)+&
            Phiss(gc,ec,hc,sc,ac,tc-1)*vals(1)*pi(ec,scc,sc)*pi_h(ec,tc-1,hcc,hc)
            Phiss(1,ec,hcc,scc,inds(2),tc)=Phiss(1,ec,hcc,scc,inds(2),tc)+&
            Phiss(gc,ec,hc,sc,ac,tc-1)*vals(2)*pi(ec,scc,sc)*pi_h(ec,tc-1,hcc,hc)

            else if ( g_dgss(gc,ec,hc,sc,ac,tc-1) .eq. 0 .and. ( gc .eq. 1 .or. gc .eq. 2 ) ) then 

            Phiss(2,ec,hcc,scc,inds(1),tc)=Phiss(2,ec,hcc,scc,inds(1),tc)+&
            Phiss(gc,ec,hc,sc,ac,tc-1)*vals(1)*pi(ec,scc,sc)*pi_h(ec,tc-1,hcc,hc)
            Phiss(2,ec,hcc,scc,inds(2),tc)=Phiss(2,ec,hcc,scc,inds(2),tc)+&
            Phiss(gc,ec,hc,sc,ac,tc-1)*vals(2)*pi(ec,scc,sc)*pi_h(ec,tc-1,hcc,hc)
		
            else if ( gc .eq. 3  .and. g_dgss(gc,ec,hc,sc,ac,tc-1) .eq. 1 ) then 

            Phiss(1,ec,hcc,scc,inds(1),tc)=Phiss(1,ec,hcc,scc,inds(1),tc)+&
            Phiss(gc,ec,hc,sc,ac,tc-1)*vals(1)*pi(ec,scc,sc)*pi_h(ec,tc-1,hcc,hc)
            Phiss(1,ec,hcc,scc,inds(2),tc)=Phiss(1,ec,hcc,scc,inds(2),tc)+&
            Phiss(gc,ec,hc,sc,ac,tc-1)*vals(2)*pi(ec,scc,sc)*pi_h(ec,tc-1,hcc,hc)

            else if ( gc .eq. 3  .and. g_dgss(gc,ec,hc,sc,ac,tc-1) .eq. 0 ) then 
										
            Phiss(3,ec,hcc,scc,inds(1),tc)=Phiss(3,ec,hcc,scc,inds(1),tc)+&
            Phiss(gc,ec,hc,sc,ac,tc-1)*vals(1)*pi(ec,scc,sc)*pi_h(ec,tc-1,hcc,hc)
            Phiss(3,ec,hcc,scc,inds(2),tc)=Phiss(3,ec,hcc,scc,inds(2),tc)+&
            Phiss(gc,ec,hc,sc,ac,tc-1)*vals(2)*pi(ec,scc,sc)*pi_h(ec,tc-1,hcc,hc)
		
            end if
						
        end do
        end do
    
    end do
    end do
    end do
    end do
    end do
    end do

phissadjusted=0
phisstrue=0

    do tc=1,J
    do ec=1,ne
    do hc=1,nh
    
    dummy=sum(phiss(:,ec,hc,:,:,tc))
    
        do gc=1,ng
        do sc=1,ns
        do ac=1,na
        
            if ( dummy .gt. zero ) then
            phissadjusted(gc,ec,hc,sc,ac,tc)=phiss(gc,ec,hc,sc,ac,tc)/dummy
            phisstrue(gc,ec,hc,sc,ac,tc)=phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)	
            else
            phissadjusted(gc,ec,hc,sc,ac,tc)=0
            end if
            
        end do		
        end do
        end do
        
    end do	
    end do
    end do

! Find Stationary Distribution over Asset holdings
	
    do tc=1,J
    do ec=1,ne
    do hc=1,nh
            if ( Nuss(ec,hc,tc)*sum(Phissadjusted(:,ec,hc,:,na,tc)) .gt. zero .and. rank .eq. 0 ) then
            print*,'Enlarge Grid (printed from distss.f90)', Nuss(ec,hc,tc)*sum(Phissadjusted(:,ec,hc,:,na,tc))
                call exit
            end if
    end do
    end do
    end do

ADisss=0

    do ac=1,na
    do tc=1,J
    do ec=1,ne
    do hc=1,nh
    help(ec,hc,tc)=sum(Phissadjusted(:,ec,hc,:,ac,tc))
    Adisss(ac)=Adisss(ac)+help(ec,hc,tc)*Nuss(ec,hc,tc)/sum(Nuss)
    end do
    end do
    end do
    end do

	
    if ( sum(ADisss) > 1.01d0 .and. rank .eq. 0 ) then
    print*,'Should equal 1', sum(ADisss)
            call exit
    endif

! Find Aggregate Asset Holdings (end of Period)

Asss=0
N1ss=0
hourss=0
    Css=0
Hss=0

    do tc=1,J
    do ec=1,ne
    do hc=1,nh
    
    economy=economyss(tc)

    abarss=0
    lbarss=0
    labarss=0
    cbarss=0
    hbarss=0
            
        if ( hc .gt. nh/2 ) then
        sick=1
        else
        sick=0
        end if

        do gc=1,ng
        do sc=1,ns
        
        abarss=abarss+ sum( Phissadjusted(gc,ec,hc,sc,1:na,tc)*afunss(gc,ec,hc,sc,1:na,tc) )+&
        pr_gss(ec,hc,tc)*sum(g_dgss(gc,ec,hc,sc,1:na,tc)*Phissadjusted(gc,ec,hc,sc,1:na,tc))

        lbarss=lbarss+sum(eta(ec,sc)*ep(ec,tc)*z_h(hc)*&
        Phissadjusted(gc,ec,hc,sc,1:na,tc)*lfunss(gc,ec,hc,sc,1:na,tc))

        labarss=labarss+ sum(Phissadjusted(gc,ec,hc,sc,1:na,tc)*lfunss(gc,ec,hc,sc,1:na,tc))
        cbarss=cbarss+ sum(Phissadjusted(gc,ec,hc,sc,1:na,tc)*cfunss(gc,ec,hc,sc,1:na,tc))
        hbarss=hbarss+ e_h(hc,tc)*sum(Phissadjusted(gc,ec,hc,sc,1:na,tc))
    
        end do
        end do

    Asss=Asss+Nuss(ec,hc,tc)*abarss
    N1ss=N1ss+Nuss(ec,hc,tc)*lbarss
    Css=Css+Nuss(ec,hc,tc)*cbarss
    hourss=hourss+Nuss(ec,hc,tc)*labarss/sum(Nuss)
    Hss=Hss+Nuss(ec,hc,tc)*hbarss
            
    end do
    end do
    end do

!calculating average hours of wap
hourss=hourss*sum(Nuss)/sum(Nuss(:,:,1:jr-1))

!distribution condtional on tc
phissage=0

    do tc=1,J
    
    dummy=sum(phisstrue(:,:,:,:,:,tc))
    
        do gc=1,ng
        do ec=1,ne
        do hc=1,nh
        do sc=1,ns
        do ac=1,na
        
            if ( dummy .gt. zero ) then
            phissage(gc,ec,hc,sc,ac,tc)=phisstrue(gc,ec,hc,sc,ac,tc)/dummy
            else
            phissage(gc,ec,hc,sc,ac,tc)=0
            end if
            
        end do		
        end do
        end do
        end do	
        end do
        
    end do

labarssbyage=0
savingsbyage=0
    consbyage=0
    cons1byage=0
savings1byage=0
labincbyage=0
savings2byage=0
nettransfersbyage=0
medicaidtypebyagess=0

    do tc=1,J
    
        do ec=1,ne
        do hc=1,nh
        do gc=1,ng
        do sc=1,ns
                
        labarssbyage(tc)=labarssbyage(tc)+sum(Phissadjusted(gc,ec,hc,sc,1:na,tc)*lfunss(gc,ec,hc,sc,1:na,tc))*&
        nuss(ec,hc,tc)
        consbyage(tc)=consbyage(tc)+sum(Phissadjusted(gc,ec,hc,sc,1:na,tc)*cfunss(gc,ec,hc,sc,1:na,tc))*&
        nuss(ec,hc,tc)
        cons1byage(tc)=cons1byage(tc)+(sum(Phissadjusted(gc,ec,hc,sc,1:na,tc)*cfunss(gc,ec,hc,sc,1:na,tc))+&
        e_h(hc,tc)*sum(Phissadjusted(gc,ec,hc,sc,1:na,tc)))*nuss(ec,hc,tc)
        labincbyage(tc)=labincbyage(tc)+sum(Phissadjusted(gc,ec,hc,sc,1:na,tc)*&
        eta(ec,sc)*ep(ec,tc)*z_h(hc)*lfunss(gc,ec,hc,sc,1:na,tc)*wss)*nuss(ec,hc,tc)

            do ac=1,na

            savingsbyage(tc)=savingsbyage(tc)+Phissadjusted(gc,ec,hc,sc,ac,tc)*afunss(gc,ec,hc,sc,ac,tc)*&
            nuss(ec,hc,tc)
            savings1byage(tc)=savings1byage(tc)+Phissadjusted(gc,ec,hc,sc,ac,tc)*&
            (afunss(gc,ec,hc,sc,ac,tc)-grida(ac))*&
            nuss(ec,hc,tc)
            savings2byage(tc)=savings2byage(tc)+Phissadjusted(gc,ec,hc,sc,ac,tc)*grida(ac)*&
            nuss(ec,hc,tc)
            nettransfersbyage(tc)=nettransfersbyage(tc)+(Phissadjusted(gc,ec,hc,sc,ac,tc)*&
            (cfunss(gc,ec,hc,sc,ac,tc)+e_h(hc,tc)+afunss(gc,ec,hc,sc,ac,tc)-grida(ac)-&
            eta(ec,sc)*ep(ec,tc)*z_h(hc)*lfunss(gc,ec,hc,sc,ac,tc)*wss))*&
            nuss(ec,hc,tc)

                !eligible for Medicaid
                if ( g_dmss(gc,ec,hc,sc,ac,tc) .eq. 1 ) then
                
                xmed=medicaidexpfunss(gc,ec,hc,sc,ac,tc)/cov_mdss(tc)
                alevel=grida(ac)

                    if ( tc .lt. jr ) then
                    yinc=wss*eta(ec,sc)*ep(ec,tc)*z_h(hc)*lfunss(gc,ec,hc,sc,ac,tc)+rss*(grida(ac))
                    else if ( tc .ge. jr ) then
                    yinc=rss*(grida(ac))+wss*eta(ec,sc)*ep(ec,tc)*z_h(hc)*lfunss(gc,ec,hc,sc,ac,tc)+SSss(ec)
                    end if

                    if ( ( yinc .le. ycatss .and.  alevel .le. kcatss ) .and. ( yinc-xmed .le. ymnss .and. alevel .le. kmnss ) ) then
                    medicaidtypebyagess(1,tc)=medicaidtypebyagess(1,tc)+Phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)
                    else if  ( ( yinc .le. ycatss .and.  alevel .le. kcatss ) ) then
                    medicaidtypebyagess(2,tc)=medicaidtypebyagess(2,tc)+Phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)
                    else if ( yinc-xmed .le. ymnss .and. alevel .le. kmnss ) then
                    medicaidtypebyagess(3,tc)=medicaidtypebyagess(3,tc)+Phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)
                    end if
                    
                end if
                
            end do
            
        
        end do
        end do
        end do
        end do

    labarssbyage(tc)=labarssbyage(tc)/sum(nuss(:,:,tc))
    consbyage(tc)=consbyage(tc)/sum(nuss(:,:,tc))
    cons1byage(tc)=cons1byage(tc)/sum(nuss(:,:,tc))
    labincbyage(tc)=labincbyage(tc)/sum(nuss(:,:,tc))
    savingsbyage(tc)=savingsbyage(tc)/sum(nuss(:,:,tc))
    savings1byage(tc)=savings1byage(tc)/sum(nuss(:,:,tc))
    savings2byage(tc)=savings2byage(tc)/sum(nuss(:,:,tc))
    nettransfersbyage(tc)=nettransfersbyage(tc)/sum(nuss(:,:,tc))
    medicaidtypebyagess(:,tc)=medicaidtypebyagess(:,tc)/sum(nuss(:,:,tc))
 
    end do

end Subroutine distss