subroutine fistst

use params
use mini
implicit none
external residss

integer :: cnt1, cnt2, ucnt2, check(nl), tempcnt(nl)
double precision, allocatable :: temp1(:,:), temp2(:,:), temp3(:,:)
double precision, allocatable :: adist(:,:), lidist(:,:), edist(:,:)

! Initialize Variables
economyss(:)=economy_t(:,time)
Nuss=Nu(1:ne,1:nh,1:J,time)
bss(:)=b(:,time)
taukss=tauk(time)
taulss=taul(time)
gconss=gcon(time)

    !Medicare coverage
    cov_mss=cov_m(time)

    !Medicaid coverage
    cov_mdss=cov_md(time,:)

ycatss=ycat(time)
kcatss=kcat(time)
ymnss=ymn(time)
kmnss=kmn(time)

    conditionss=condition(time)
min_penss=min_pen(time) 
pen_ratess=pen_rate(time)
file_minss=file_min(time)
min_prss=min_pr(time)

ACAsubss=ACAsub(time)
allbuyss=allbuy(time)

put_e=put_e_t(:,time)
psi=psi_t(:,:,:,time)

!initial guesses
open (unit=1,file='input_fistst_guess.txt')
read(1,*)rss,Nss,Trss,ghexpss,taufss
close(1)

    if ( conditionss .eq. 0 ) then
    
    pr_gss=0
    
        do ec=1,ne
        do tc=1,J-1
            do hc=1,nh
                if ( tc .lt. jr-1 ) then
                pr_gss(ec,1,tc)=pr_gss(ec,1,tc)+psi(ec,hc,tc)*Nuss(ec,hc,tc)*cov_p(hc)*sum(pi_h(ec,tc,1:nh,hc)*e_h(1:nh,tc+1))    
                else
                pr_gss(ec,1,tc)=pr_gss(ec,1,tc)+psi(ec,hc,tc)*Nuss(ec,hc,tc)*cov_p(hc)*(1-cov_mss)*sum(pi_h(ec,tc,1:nh,hc)*e_h(1:nh,tc+1)) 
                end if                    
            end do
        pr_gss(ec,1,tc)=pr_gss(ec,1,tc)/((1+rss)*sum(Nuss(ec,:,tc)))
        pr_gss(ec,2:nh,tc)=pr_gss(ec,1,tc)
        end do
        end do
        
        open (unit=1,file='input_fistst_insurance_price_guess.txt')
            do tc=1,J
            read(1,*)pr_gss(1,:,tc),pr_gss(2,:,tc)
            end do
        close(1)
        
    end if

! rss=1.49340758788188612E-002
! Nss=15.996144718148610
! Trss=2.19776622124290069E-002
! ghexpss=0.80797358106424189
! taufss=6.15425216505242484E-002

! Call the Function that solves for steady state equilibrium r,N
	call Newton1ss(residss,rss,Nss)

! Compute Dispersion of Wealth and Income
	call variance (coevarl(2),coevarw(2))

! Check Market Clearing in goods market
Kss=((alpha*theta)/(rss+delta))**(1.0/(1-alpha))*Nss
Yss=theta*(Kss**alpha)*(Nss**(1-alpha))
exdemss=Css+(nn+delta)*Kss+Hss-Yss

	if ( rank .eq. 0 ) then

            open (unit=1,file='input_fistst_guess.txt')
            write(1,*)rss,Nss,Trss,ghexpss,taufss
            close(1)
		
	print*,'excess demand in goods market ', exdemss
!	print*,'Kss, Nss, Hss, Css, Yss ',Kss,Nss,Hss,Css,Yss
!	print*,'rss, Nss, Trss, ghexpss, taufss ',rss, Nss, Trss, ghexpss, taufss

            open (unit=1,file='input_fistst_insurance_price_guess.txt')
                do tc=1,J
                write(1,*)pr_gss(1,:,tc),pr_gss(2,:,tc)
                end do
            close(1)

	end if


! Save Output

r(time)=rss
w(time)=wss
K(time)=Kss
N(time)=Nss
Y(time)=Yss
	C(time)=Css
H(time)=Hss
Tr(time)=Trss
taup(time)=taupss
ghexp(time)=ghexpss
tauf(time)=taufss
pr_g(:,:,:,time)=pr_gss

!saving for voting.f90 and welfare.f90
Vtime(1:ng,1:ne,1:nh,1:ns,1:na,1:J+1)=Vss
Phissagetime=Phissage
g_dmsstime=g_dmss
Vborn(:,:,:,:,time)=Vss(:,:,:,:,1,1)

ADis(1:na,time)=ADisss

hour(time)=hourss
tauk(time)=taukss
taul(time)=taulss

SS(:,time)=SSss(:)
As(time)=Asss

exdem(time)=exdemss

safety(time)=safetyss
safetycnt(time)=safetycntss

!compute insurance distribution by expense
    call insexpdist (insexp(7:12),insexpage(:,7:12),insexpedu(:,7:12),insexpasset(:,7:12),insexphealth(:,7:12),insexpprod(:,7:12))

!compute insurance distribution by head count

    do tc=1,J
    do ec=1,ne
    do hc=1,nh
    do gc=1,ng
    do sc=1,ns
    do ac=1,na

        if ( hifunss(gc,ec,hc,sc,ac,tc) .eq. 1 ) then
        ins(7)=ins(7)+phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)/sum(nuss)
        insage(tc,7)=insage(tc,7)+phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)/sum(nuss)
        insedu(ec,7)=insedu(ec,7)+phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)/sum(nuss)
        insasset(ac,7)=insasset(ac,7)+phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)/sum(nuss)
        inshealth(hc,7)=inshealth(hc,7)+phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)/sum(nuss)
        insprod(sc,7)=insprod(sc,7)+phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)/sum(nuss)

        else if ( hifunss(gc,ec,hc,sc,ac,tc) .eq. 2 ) then
        ins(8)=ins(8)+phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)/sum(nuss)
        insage(tc,8)=insage(tc,8)+phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)/sum(nuss)
        insedu(ec,8)=insedu(ec,8)+phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)/sum(nuss)
        insasset(ac,8)=insasset(ac,8)+phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)/sum(nuss)
        inshealth(hc,8)=inshealth(hc,8)+phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)/sum(nuss)
        insprod(sc,8)=insprod(sc,8)+phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)/sum(nuss)

        else if ( hifunss(gc,ec,hc,sc,ac,tc) .eq. 3 ) then
        ins(9)=ins(9)+phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)/sum(nuss)
        insage(tc,9)=insage(tc,9)+phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)/sum(nuss)
        insedu(ec,9)=insedu(ec,9)+phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)/sum(nuss)
        insasset(ac,9)=insasset(ac,9)+phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)/sum(nuss)
        inshealth(hc,9)=inshealth(hc,9)+phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)/sum(nuss)
        insprod(sc,9)=insprod(sc,9)+phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)/sum(nuss)

        else if ( hifunss(gc,ec,hc,sc,ac,tc) .eq. 4 ) then
        ins(10)=ins(10)+phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)/sum(nuss)
        insage(tc,10)=insage(tc,10)+phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)/sum(nuss)
        insedu(ec,10)=insedu(ec,10)+phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)/sum(nuss)
        insasset(ac,10)=insasset(ac,10)+phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)/sum(nuss)
        inshealth(hc,10)=inshealth(hc,10)+phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)/sum(nuss)
        insprod(sc,10)=insprod(sc,10)+phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)/sum(nuss)

        else if ( hifunss(gc,ec,hc,sc,ac,tc) .eq. 5 ) then
        ins(11)=ins(11)+phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)/sum(nuss)
        insage(tc,11)=insage(tc,11)+phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)/sum(nuss)
        insedu(ec,11)=insedu(ec,11)+phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)/sum(nuss)
        insasset(ac,11)=insasset(ac,11)+phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)/sum(nuss)
        inshealth(hc,11)=inshealth(hc,11)+phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)/sum(nuss)
        insprod(sc,11)=insprod(sc,11)+phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)/sum(nuss)

        else if ( hifunss(gc,ec,hc,sc,ac,tc) .eq. 6 ) then
        ins(12)=ins(12)+phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)/sum(nuss)
        insage(tc,12)=insage(tc,12)+phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)/sum(nuss)
        insedu(ec,12)=insedu(ec,12)+phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)/sum(nuss)
        insasset(ac,12)=insasset(ac,12)+phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)/sum(nuss)
        inshealth(hc,12)=inshealth(hc,12)+phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)/sum(nuss)
        insprod(sc,12)=insprod(sc,12)+phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)/sum(nuss)

        end if
        
    end do
    end do
    end do
    end do
    end do
    end do

pvtinsuredss=ins(7)
selfinsuredss=ins(8)
employerss=ins(9)
medicaress=ins(10)
foodstampss=ins(11)
medicaidss=ins(12)	

pvtinsured(time)=pvtinsuredss
selfinsured(time)=selfinsuredss
employer(time)=employerss
medicare(time)=medicaress
foodstamp(time)=foodstampss
medicaid(time)=medicaidss

    cnt1=0

    do ac=1,na
        if ( sum(phissadjusted(:,:,:,:,ac,:)) .gt. zero ) then
        cnt1=cnt1+1
        end if
    end do

    allocate (temp1(cnt1,2))
    cnt1=0
    temp1=0
        do ac=1,na
            if ( sum(phissadjusted(:,:,:,:,ac,:)) .gt. zero ) then
            cnt1=cnt1+1
            temp1(cnt1,1)=grida(ac)+Trss
                do ec=1,ne
                do hc=1,nh
                do tc=1,J
                temp1(cnt1,2)=temp1(cnt1,2)+sum(phissadjusted(:,ec,hc,:,ac,tc))*nuss(ec,hc,tc)/sum(nuss)
                end do
                end do
                end do
            end if
        end do

    !assets
    allocate(adist(cnt1+1,2))
    adist=zero
    call lorenz(temp1,cnt1,adist(2:cnt1+1,:),cnt1,ginicoefassets(3),cvassets(3),&
    vlogassets(3),avgassets(3),medianassets(3))
    call ineqmoments(adist,cnt1+1,quintassets(3,:),topassets(3,:))
    deallocate(temp1,adist)

    if ( rank .eq. 0 ) then
    print*,'computed wealth distribution at fistst '
    end if

    cnt2=0
    cnt2=cnt2+1

    do tc=1,J
    do ec=1,ne
    do sc=1,ns
    do hc=1,nh
    check=0
        do gc=1,ng
        do ac=1,na	

            do il=1,nl
                if ( phissadjusted(gc,ec,hc,sc,ac,tc) .gt. zero .and. lfunss(gc,ec,hc,sc,ac,tc) .eq. gridl(il) .and. check(il) .eq. 0 ) then
                check(il)=1
                cnt2=cnt2+1
                end if
            end do

        end do
        end do
    end do
    end do
    end do
    end do

!    cnt2=cnt2+ne

    allocate (temp2(cnt2,2))

    cnt2=0
    cnt2=cnt2+1
temp2=0

    do tc=1,J
    do ec=1,ne
    do sc=1,ns
    do hc=1,nh
    check=0
        do gc=1,ng
        do ac=1,na	

            if ( phissadjusted(gc,ec,hc,sc,ac,tc) .gt. zero ) then 

                do il=1,nl
                    if ( lfunss(gc,ec,hc,sc,ac,tc) .eq. gridl(il) .and. check(il) .eq. 0 ) then
                    check(il)=1
                    cnt2=cnt2+1
!                        if ( tc .le. jr-1 ) then
                        temp2(cnt2,1)=wss*eta(ec,sc)*ep(ec,tc)*z_h(hc)*lfunss(gc,ec,hc,sc,ac,tc)
!                        else
!                        temp2(cnt2,1)=wss*eta(ec,sc)*ep(ec,tc)*z_h(hc)*lfunss(gc,ec,hc,sc,ac,tc)+SSss(ec)
!                        end if 
                    temp2(cnt2,2)=phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)/sum(nuss)
                    tempcnt(il)=cnt2
						
                    else if ( lfunss(gc,ec,hc,sc,ac,tc) .eq. gridl(il) .and. check(il) .eq. 1 ) then
                    temp2(tempcnt(il),2)=temp2(tempcnt(il),2)+phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)/sum(nuss)
                    end if
                end do

!                if ( lfunss(gc,ec,hc,sc,ac,tc) .eq. zero .and. tc .le. jr-1  ) then
                if ( lfunss(gc,ec,hc,sc,ac,tc) .eq. zero ) then
                
                temp2(1,2)=temp2(1,2)+phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)/sum(nuss)
                end if

            end if

        end do
        end do
    end do
    end do
    end do
    end do

!     do ec=1,ne
!     cnt2=cnt2+1
!     temp2(cnt2,1)=SSss(ec)
!         do hc=1,nh
!         do tc=jr,J
!             if ( lfunss(gc,ec,hc,sc,ac,tc) .eq. zero ) then                
!             temp2(cnt2,2)=temp2(cnt2,2)+sum(phissadjusted(:,ec,hc,:,:,tc))*nuss(ec,hc,tc)/sum(nuss)
!             end if
!         end do
!         end do
!     end do
	
	
    !labor earnings
    call sort(temp2,cnt2)
    call unique(temp2,cnt2,ucnt2)
    allocate(lidist(ucnt2+1,2))
    lidist=zero
    call lorenz(temp2,cnt2,lidist(2:ucnt2+1,:),ucnt2,ginicoeflabearnings(3),cvlabearnings(3),&
    vloglabearnings(3),avglabearnings(3),medianlabearnings(3))
    call persistence (zero,.8d0,phisstrue,pb80(3),temp2,cnt2,ucnt2)
    call persistence (zero,.99d0,phisstrue,pt99(3),temp2,cnt2,ucnt2)
    call ineqmoments(lidist,ucnt2+1,quintlabearnings(3,:),toplabearnings(3,:))
    deallocate(temp2,lidist)

    if ( rank .eq. 0 ) then
    print*,'computed labor earnings distribution at fistst '
    end if

    if ( rank .eq. 0 ) then
    

	open (unit=1,file='output_stst_insurance_expense.txt')
	write(1,*)'H Pvt Self Emp Mcare Fstamp Mcaid Pvt Self Emp Mcare Fstamp Mcaid '
	write(1,'(300F12.5)')hss,insexp
	write(1,*)
	write(1,*)'Age Pvt Self Emp Mcare Fstamp Mcaid Pvt Self Emp Mcare Fstamp Mcaid '
		do tc=1,J
		write(1,'(I2,300F12.5)')tc+19,insexpage(tc,:)
		end do
	write(1,*)
	write(1,*)'Edu Pvt Self Emp Mcare Fstamp Mcaid Pvt Self Emp Mcare Fstamp Mcaid '
		do ec=1,ne
		write(1,'(I2,300F12.5)')ec,insexpedu(ec,:)
		end do
	write(1,*)
	write(1,*)'a Pvt Self Emp Mcare Fstamp Mcaid Pvt Self Emp Mcare Fstamp Mcaid '
		do ac=1,na
		write(1,'(300F12.5)')grida(ac),insexpasset(ac,:)
		end do
	write(1,*)
	write(1,*)'h Pvt Self Emp Mcare Fstamp Mcaid Pvt Self Emp Mcare Fstamp Mcaid '
		do hc=1,nh
		write(1,'(I2,300F12.5)')hc,insexphealth(hc,:)
		end do
	write(1,*)
	write(1,*)'eta Pvt Self Emp Mcare Fstamp Mcaid Pvt Self Emp Mcare Fstamp Mcaid '
		do sc=1,ns
		write(1,'(I2,300F12.5)')sc,insexpprod(sc,:)
		end do
	close(1)

	open(unit=1,file='output_stst_insurance_headcount.txt')
	write(1,*)'Pvt Self Emp Mcare Fstamp Mcaid Pvt Self Emp Mcare Fstamp Mcaid'
	write(1,'(300F12.5)')ins
	write(1,*)
	write(1,*)'Age Pvt Self Emp Mcare Fstamp Mcaid Pvt Self Emp Mcare Fstamp Mcaid'
		do tc=1,j
		write(1,'(I2,300F12.5)')tc+19,insage(tc,:)
		end do
	write(1,*)
	write(1,*)'Edu Pvt Self Emp Mcare Fstamp Mcaid Pvt Self Emp Mcare Fstamp Mcaid'
		do ec=1,ne
		write(1,'(I2,300F12.5)')ec,insedu(ec,:)
		end do
	write(1,*)
	write(1,*)'a Pvt Self Emp Mcare Fstamp Mcaid Pvt Self Emp Mcare Fstamp Mcaid'
		do ac=1,na
		write(1,'(300F12.5)')grida(ac),insasset(ac,:)
		end do
	write(1,*)
	write(1,*)'h Pvt Self Emp Mcare Fstamp Mcaid Pvt Self Emp Mcare Fstamp Mcaid'
		do hc=1,nh
		write(1,'(I2,300F12.5)')hc,inshealth(hc,:)
		end do
	write(1,*)
	write(1,*)'eta Pvt Self Emp Mcare Fstamp Mcaid Pvt Self Emp Mcare Fstamp Mcaid'
		do sc=1,ns
		write(1,'(I2,300F12.5)')sc,insprod(sc,:)
		end do
	close(1)

        open (unit=1,file='output_fistst_age_profile.txt')
        write(1,*)'age lbar ap c pop c+h sav labinc a trans both cat MN '
            do tc=1,J
            write(1,'(I2,300F12.5)')tc+19,labarssbyage(tc),savingsbyage(tc),consbyage(tc),sum(Nuss(:,:,tc)),&
            cons1byage(tc), savings1byage(tc), labincbyage(tc), savings2byage(tc),nettransfersbyage(tc),medicaidtypebyagess(:,tc)
            end do
        close(1)
		
        open (unit=1,file='output_fistst_insurance_prices.txt')
        write(1,*)'age nc1 nc2 nc3 nc4 nc5 nc6 c1 c2 c3 c4 c5 c6 '
            do tc=1,J
            write(1,'(I2,300F12.5)')tc+19,pr_gss(1,:,tc),pr_gss(2,:,tc)
            end do
        close(1)
            

        !steadystate results
        open (unit=1,file='output_stst_aggregates.txt')
        write(1,*)'economy ','initial ','final '
        write(1,*)'b_nc ',b(1,1),b(1,time)
        write(1,*)'b_c ',b(2,1),b(2,time)
        write(1,*)'r ',r(1),r(time)
        write(1,*)'w ',w(1),w(time)
        write(1,*)'tau_l ',taup(1),taup(time)	
        write(1,*)'tau_f ',tauf(1),tauf(time)
        write(1,*)'lbar ',hour(1),hour(time)
        write(1,*)'K/Y ',K(1)/Y(1),K(time)/Y(time)
        write(1,*)'y ',Y(1)/(Sum(Nuss)),Y(time)/sum(Nuss)
        write(1,*)'N ',N(1),N(time)
        write(1,*)'Tr ',Tr(1),Tr(time)
        write(1,*)'K ',K(1),K(time)
        write(1,*)'exdem ',exdem(1),exdem(time)
        write(1,*)'coefficient_of_var_lab_income ',coevarl
        write(1,*)'coefficient_of_var_wealth ',coevarw
        write(1,*)'con ',c(1),c(time)
        write(1,*)'pop ',sum(nu(:,:,:,1)),sum(nu(:,:,:,time))
        write(1,*)'spending_welfare ',safety(1), safety(time)
        write(1,*)'pop_welfare ',safetycnt(1),safetycnt(time)
        close(1)

    quintassets=quintassets*100
    quintlabearnings=quintlabearnings*100
    topassets=topassets*100
    toplabearnings=toplabearnings*100
    
        open(unit=1,file='output_stst_inequality_table.txt')
        write(1,*)'1 2 3 4 5 90-95 95-99 99-100 gini'
        write(1,*)'assets'
        write(1,'(300F12.5)')quintassets(1,:),topassets(1,:),ginicoefassets(1)
        write(1,'(300F12.5)')quintassets(2,:),topassets(2,:),ginicoefassets(2)
        write(1,'(300F12.5)')quintassets(3,:),topassets(3,:),ginicoefassets(3)
        write(1,*)'labor_earnings'
        write(1,'(300F12.5)')quintlabearnings(1,:),toplabearnings(1,:),ginicoeflabearnings(1)
        write(1,'(300F12.5)')quintlabearnings(2,:),toplabearnings(2,:),ginicoeflabearnings(2)
        write(1,'(300F12.5)')quintlabearnings(3,:),toplabearnings(3,:),ginicoeflabearnings(3)
        close(1)

    print*,'BOTH STEADY STATE STATISTICS HAVE BEEN WRITTEN '
    print*,' '
    
    end if

end subroutine fistst
