! This subroutine defines the stochastic process for labor productivity
subroutine markov
use params
implicit none

double precision,dimension(ne,ns) :: put0

!variables to get stationary markov
integer :: iter_markov
integer, parameter :: itmax_markov=5000
double precision, parameter :: tol_markov=1e-9
double precision ::d_markov, dummy

		
!no highschool, highschool, and college (
! pi(2,:,:)=pi(1,:,:)
! eta(2,:)=eta(1,:)

! Define Markov Transition Matrix: pi(i,j)=prob(state tom.=i|state today =j)

! pi(:,1,1)=0.8826
! pi(:,2,1)=0.0949
! pi(:,3,1)=0.0146
! pi(:,4,1)=0.0079
! 
! pi(:,1,2)=0.0839
! pi(:,2,2)=0.8117
! pi(:,3,2)=0.0912
! pi(:,4,2)=0.0134
! 
! 
! pi(:,1,3)=0.0038
! pi(:,2,3)=0.0825
! pi(:,3,3)=0.8461
! pi(:,4,3)=0.0676
! 
! pi(:,1,4)=0.0032
! pi(:,2,4)=0.0208
! pi(:,3,4)=0.0582
! pi(:,4,4)=0.9178
! ! 
! ! ! Define states for idiosyncratic uncertainty
! ! 
! eta(:,1)=0.16
! eta(:,2)=0.62
! eta(:,3)=1.17
! eta(:,4)=3.07

	do ec=1,ne
        do sc=1,ns
        dummy=sum(pi(ec,:,sc))
        pi(ec,:,sc)=pi(ec,:,sc)/dummy
        end do
	end do

! Compute stationary distribution over labor productivity
put0=1./ns

	do ec=1,ne
	iter_markov=0
	d_markov=1

            do while ( iter_markov .lt. itmax_markov .and. d_markov .gt. tol_markov )

            put(ec,:)=MATMUL(put0(ec,:),TRANSPOSE(pi(ec,:,:)))
            d_markov=MAXVAL(ABS(put0(ec,:)-put(ec,:)))
            put0(ec,:)=put(ec,:)
            iter_markov=iter_markov+1
    
            end do
            
	end do


end subroutine markov