subroutine resid

use params
implicit none

integer :: t
double precision :: dummy
! Compute Aggregate Variables

    do t=3,time-1
    ! Capital Stock
    K(t)=((alpha*theta)/(r(t)+delta))**(1.0/(1-alpha))*N(t)
    end do

    do t=2,time-1
    ! Aggregate Output
    Y(t)=theta*(K(t)**alpha)*(N(t)**(1.0-alpha))			
    ! Wages
    w(t)=(1-alpha)*(Y(t)/N(t))		
    
    ! Social Security Benefits
        do ec=1,ne
        SS(ec,t)=b(ec,t)*N(t)*w(t)/sum( Nu(1:ne,1:nh,1:jr-1,t) )				
        end do
        
    dummy=0
        do ec=1,ne
        dummy=dummy+SS(ec,t)*sum(Nu(ec,1:nh,jr:J,t))
        end do

!SS(t)*sum(Nu(1:ne,1:nh,jr:J,t))
    taup(t)=(dummy+ghexp(t))/ (w(t)*N(t))

    end do

! Government Budget Constraint 

    do t=2,time-1
    taul(t)=(gcon(t)-tauk(t)*r(t)*K(t)/Y(t))/(w(t)*N(t)/Y(t))
    end do

! Solve for Households Decision Rules and simulate distribution
    call house

! Get new guesses for interest rate (labor supply is already solved for)

K1(1)=K(1)
K1(2)=K(2)
K1(time)=K(time)

    do t=3,time-1
    K1(t)=As(t-1)/(1+nn)
    end do

    do t=2,time-1
    r1(t)=theta*alpha*(N1(t)/K1(t))**(1-alpha)-delta
    end do

end subroutine resid