!given guesses for rss, Nss, computes excess demand for capital and labor
subroutine residss(x1,x2,fv1,fv2)

use params
implicit none

double precision,intent(in)::x1,x2
double precision,intent(out)::fv1,fv2
double precision :: dummy

rss=x1
Nss=x2

    !may condition on health
    if ( conditionss .eq. 1 ) then
    
    pr_gss=0
        
    !find price of pvt insurance
	do ec=1,ne
        do hc=1,nh
        do tc=1,J-1
        
            if ( tc .lt. jr-1 ) then
            pr_gss(ec,hc,tc)=cov_p(hc)*psi(ec,hc,tc)*sum(pi_h(ec,tc,1:nh,hc)*e_h(1:nh,tc+1))/(1+rss)
            else if ( tc .ge. jr-1 ) then
            pr_gss(ec,hc,tc)=cov_p(hc)*psi(ec,hc,tc)*(1-cov_mss)*sum(pi_h(ec,tc,1:nh,hc)*e_h(1:nh,tc+1))/(1+rss)
            end if
            
        end do
        end do
	end do       
        
    end if
    
! Capital Stock
Kss=((alpha*theta)/(rss+delta))**(1.0/(1-alpha))*Nss	
! Aggregate Output
Yss=theta*(Kss**alpha)*(Nss**(1-alpha))					
! Wages
wss=(1-alpha)*Yss/Nss									

! Social Security Benefits
    do ec=1,ne
    SSss(ec)=bss(ec)*wss*Nss/sum(Nuss(1:ne,1:nh,1:jr-1))
    end do

dummy=0

    do ec=1,ne
    dummy=dummy+SSss(ec)*sum(Nuss(ec,:,jr:J))
    end do

!SSss*sum(Nuss(1:ne,1:nh,jr:J))
taupss=(dummy+ghexpss)/(wss*Nss)

! Government Budget Constraint: Solve for Taxes on Labor Income (zero in current set up)
taulss=(gconss-(Kss*taukss*rss/Yss))/(wss*Nss/Yss)

! Solve the Household Problem
    call housess

! Find stationary Distribution
    call distss 

! Define Equations for which to find solution

fv1=Asss-(1+nn)*Kss
fv2=N1ss-Nss

end subroutine residss